package com.kms.crosscut;

import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPFactory;
import javax.xml.soap.SOAPFault;
import javax.xml.ws.soap.SOAPFaultException;

public class SoapFaultHelper {

    private static final SOAPFactory soapFactory;

    static {
        try {
            soapFactory = SOAPFactory.newInstance();
        } catch (SOAPException e) {
            throw new RuntimeException(e);
        }
    }

    public static void throwFault(String faultCode, String faultString) {
        try {
            SOAPFault customFault = soapFactory.createFault();
            customFault.setFaultCode(faultCode);
            customFault.setFaultString(faultString);

            throw new SOAPFaultException(customFault);
        } catch (SOAPException ignored) {
        }

    }

}
