package com.kms.handler;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeader;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;
import java.util.Iterator;
import java.util.Set;

public class AuthHandler implements SOAPHandler<SOAPMessageContext> {

    private static final String REST_API_KEY = System.getenv("REST_API_KEY");
    private static final String MONOLITH_API_KEY = System.getenv("MONOLITH_API_KEY");
    private static final String NAMESPACE = "http://service.kms.com/";

    @Override
    public Set<QName> getHeaders() {
        return null;
    }

    @Override
    public boolean handleMessage(SOAPMessageContext soapMessageContext) {
        final boolean messageHandled =
                (boolean) soapMessageContext.getOrDefault("messageHandled-Auth", false);

        if (messageHandled)
            return true;

        soapMessageContext.put("messageHandled-Auth", true);
        try {
            final SOAPHeader header = soapMessageContext.getMessage().getSOAPHeader();
            final QName apiKeyQName = new QName(NAMESPACE, "apiKey");
            String apiKey = "";
            final Iterator it = header.getChildElements(apiKeyQName);
            if (it.hasNext()) {
                SOAPElement apiKeyElement = (SOAPElement) it.next();
                apiKey = apiKeyElement.getValue();
            }

            String callerId = "null";
            if (apiKey.equals(REST_API_KEY))
                callerId = "REST";
            else if (apiKey.equals(MONOLITH_API_KEY))
                callerId = "MONOLITH";

            soapMessageContext.put("callerId", callerId);
        } catch (SOAPException ignored) {
        }

        return true;
    }

    @Override
    public boolean handleFault(SOAPMessageContext soapMessageContext) {
        return false;
    }

    @Override
    public void close(MessageContext messageContext) {

    }
}
