package com.kms.task;

import com.j256.ormlite.dao.Dao;
import com.kms.model.Payment;

import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.List;
import java.util.TimerTask;

public class PaymentCompleterTask extends TimerTask {

    private final Dao<Payment, Integer> paymentDao;

    public PaymentCompleterTask(Dao<Payment, Integer> paymentDao) {
        this.paymentDao = paymentDao;
    }

    @Override
    public void run() {
        try {
            final List<Payment> paymentsNotDone = paymentDao.queryForEq("status_paid", 0);

            for (Payment p: paymentsNotDone) {
                p.setPaid(true);
                p.setPaymentPaidTime(new Timestamp(System.currentTimeMillis()));
                paymentDao.update(p);
            }
        } catch (SQLException ignored) {
        }

    }
}
